package edu.villanova.taglet;

import javax.servlet.ServletConfig;
import javax.servlet.ServletException;
import javax.servlet.ServletOutputStream;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.xml.transform.Transformer;
import javax.xml.transform.TransformerFactory;
import javax.xml.transform.stream.StreamResult;
import javax.xml.transform.stream.StreamSource;
import java.sql.DriverManager;
import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.Time;
import java.sql.Date;
import java.io.IOException;
import java.io.StringReader;
import java.io.StringWriter;
import java.io.ByteArrayOutputStream;
import org.xml.sax.InputSource;
import org.apache.fop.apps.Driver;

public class Events extends HttpServlet {

  private static String DEFAULT_TEMPLATE = "http://localhost:8080/templates/events/default.xslt";
  private static String DEFAULT_FO       = "http://localhost:8080/templates/events/fo.xslt";

  public void service (HttpServletRequest req, HttpServletResponse res) throws ServletException, IOException{
    String college = req.getParameter("college");
    String type    = req.getParameter("type");
    String template= req.getParameter("template");
    String pdf     = req.getParameter("pdf");
    Connection con          = null;
    PreparedStatement state = null;
    ResultSet result        = null;
    StringBuffer xml   = new StringBuffer();
    String eventtype   = null;
    String title       = null;
    String time        = null;
    String date        = null;
    String description = null;
    String link        = null;
    ServletOutputStream out = res.getOutputStream();
    try {

      //Checking inputs and setting default values
      if(college == null) {
        throw new Exception("The college attrubute is required!");
      }
      if(template == null) {
        template = DEFAULT_TEMPLATE;
      }

      //Getting data
      Class.forName ("sun.jdbc.odbc.JdbcOdbcDriver");
      con = DriverManager.getConnection("jdbc:odbc:Events");
      if(type==null) {
        state = con.prepareStatement("select * from events where college = ? order by date,time");
        state.setString(1,college);
      } else {
        state = con.prepareStatement("select * from events where college = ? and type = ? order by date,time");
        state.setString(1,college);
        state.setString(2,type);
      }
      result = state.executeQuery();

      //Creating the XML
      xml.append("<EVENTS COLLEGE=\"").append(college).append("\">");

      while(result.next()) {
        try {
          eventtype   = result.getString("type");
          title       = result.getString("title");
          time        = result.getTime("time").toString();
          date        = result.getDate("date").toString();
          description = result.getString("description");
          link        = result.getString("link");
          if(eventtype==null||title==null||time==null||date==null||description==null)
            continue;
          xml.append("<EVENT TYPE=\"").append(eventtype).append("\"");
          if(link!=null)
            xml.append(" LINK=\"").append(link).append("\"");
          xml.append(">");
          xml.append("<TITLE>").append(title).append("</TITLE>");
          xml.append("<DESCRIPTION>").append(description).append("</DESCRIPTION>");
          xml.append("<DATE>").append(date).append("</DATE>");
          xml.append("<TIME>").append(time).append("</TIME>");
          xml.append("</EVENT>");
        } catch (Exception e0) {}
      }
      xml.append("</EVENTS>");
      //System.out.println(xml.toString());
    } catch(Exception e) {
      e.printStackTrace();
      xml.delete(0,xml.length());
      xml.append("<ERROR>").append(e.getMessage()).append("</ERROR>");
    } finally {
      try {
        result.close();
      } catch(Exception e1) { }
      try {
        state.close();
      } catch(Exception e1) { }
      try {
        con.close();
      } catch(Exception e1) { }
    }
    if(pdf==null) {
      try {
         //Bringing the XML and XSLT together
        TransformerFactory tFactory = TransformerFactory.newInstance();
        Transformer transformer = tFactory.newTransformer(new StreamSource(template));
        transformer.transform(new StreamSource(new StringReader(xml.toString())), new StreamResult(out));
      } catch (Exception e) {
        e.printStackTrace();
      }
    } else {
      try {
        //System.out.println("working");
        StringReader sr = new StringReader(xml.toString());
        StringWriter stringWriter = new StringWriter();
        TransformerFactory tFactory = TransformerFactory.newInstance();
        Transformer transformer = tFactory.newTransformer(new StreamSource(DEFAULT_FO));
        transformer.transform(new StreamSource(sr), new StreamResult(stringWriter));

        ByteArrayOutputStream byteout = new ByteArrayOutputStream();
        res.setContentType("application/pdf");
        Driver driver = new Driver(new InputSource(new StringReader(stringWriter.getBuffer().toString())), byteout);
        driver.run();

        byte[] content = byteout.toByteArray();
        res.setContentLength(content.length);
        out.write(content);
        out.flush();

      } catch (Exception e) {
        e.printStackTrace();
      }
    }
    college     = null;
    type        = null;
    template    = null;
    con         = null;
    state       = null;
    result      = null;
    xml         = null;
    eventtype   = null;
    title       = null;
    time        = null;
    date        = null;
    description = null;
    link        = null;
  }
}